--[[
%% properties
%% events
%% globals
--]]

--[[
-----------------------------------------------------------------------------
-- BATTERY CHECKER
-----------------------------------------------------------------------------
Copyright © 2017 mysmarthome.cba.pl. 
All Rights Reserved.
Version 1.1

-- VERSION HISTORY ----------------------------------------------------------
1.0 - check and display information from all battery operated devices
1.1 - add option to send push with information about device with low battery 
level

-- COPYRIGHT NOTICE ---------------------------------------------------------
Redistribution and use of this source code, with or without modification, 
is permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

3. The name of the author may not be used to endorse or promote products 
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY  COPYRIGHT OWNER  "AS IS"  AND ANY  EXPRESS  OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY  AND FITNESS FOR A  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT  SHALL THE AUTHOR  BE  LIABLE  FOR ANY  DIRECT,  INDIRECT, INCIDENTAL, 
SPECIAL,  EXEMPLARY,  OR CONSEQUENTIAL  DAMAGES  (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT  OF SUBSTITUTE  GOODS OR  SERVICES;  LOSS OF USE,  DATA,  OR 
PROFITS;  OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON  ANY THEORY OF 
LIABILITY,  WHETHER  IN  CONTRACT,  STRICT  LIABILITY,  OR  TORT  (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

-- SCENE DESCRIPTION --------------------------------------------------------
The scene checks the status of all battery devices and displays information 
about battery levels in the debug window. It will also inform you if the level 
drops below 20%

-- HOW TO USE ---------------------------------------------------------------
Manually - just press start button
Automatically – you need to add at the beginning of the code:
local t = os.date("*t")
--scene will be performed every 19th at 10:20
if (t.day == 19) and (t.hour == 10) and (t.min == 20) then
--remember to add "end" of the end of whole code
end

this will cause the scene to start automatically once a month at a given time.
]]--

local phoneID = 168;

-- set auto start
--local t = os.date("*t")
--if (t.day == 19) and (t.hour == 10) and (t.min == 20) then
--end

prnt = function (color, message)
print(string.format('<%s style="color:%s;">%s</%s>', "span", color, message, "span", "span")) 
end

prnt("lightgreen", "Battery checker 1.1 - © 2017 mysmarthome.cba.pl");

local ids = fibaro:getDevicesId({parentId =1, interfaces ={"battery"}})
prnt("grey", "Devices to check: "..#ids..", report:")
for i,v in ipairs(ids) do
  if
    tonumber(fibaro:getValue(v, "batteryLevel")) >= 70 
    then
 	 prnt("green", "ID: " ..v.. ", '"..fibaro:getName(v+1).."', room: "..fibaro:getRoomNameByDeviceID(v+1).. " -> battery level " ..fibaro:getValue(v, "batteryLevel"))
 	 	elseif
    	tonumber(fibaro:getValue(v, "batteryLevel")) <= 69
    	and
    	tonumber(fibaro:getValue(v, "batteryLevel")) >= 45
    	then
    	prnt("lightgreen", "ID: " ..v.. ", '"..fibaro:getName(v+1).."', room: "..fibaro:getRoomNameByDeviceID(v+1).. " -> battery level " ..fibaro:getValue(v, "batteryLevel"))
  			elseif
    		tonumber(fibaro:getValue(v, "batteryLevel")) <= 44
    		and
    		tonumber(fibaro:getValue(v, "batteryLevel")) >= 21
    		then
    		prnt("yellow", "ID: " ..v.. ", '"..fibaro:getName(v+1).."', room: "..fibaro:getRoomNameByDeviceID(v+1).. " -> battery level " ..fibaro:getValue(v, "batteryLevel"))
    			elseif
    			tonumber(fibaro:getValue(v, "batteryLevel")) <=20
    			then
    			prnt("red", "ID: " ..v.. ", '"..fibaro:getName(v+1).."', room: "..fibaro:getRoomNameByDeviceID(v+1).. " -> battery level " ..fibaro:getValue(v, "batteryLevel"))
  				push=("ID: " ..v.. ", '"..fibaro:getName(v+1).."', room: "..fibaro:getRoomNameByDeviceID(v+1).. " -> poziom baterii " ..fibaro:getValue(v, "batteryLevel"))
    			fibaro:call(phoneID, "sendPush", push)	
  end
end
print("---> Checked all battery operated devices <---")